--- u-boot-2011.06_original/drivers/mtd/spi/cnc1900_spi.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/cnc1900_spi.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,878 @@
+/**/
+#include <common.h>
+#include <command.h>
+#include "cnc1900_spi.h"
+
+DECLARE_GLOBAL_DATA_PTR;
+
+#if defined(CONFIG_CMD_SF)
+
+#define CONFIG_SPI_DMA_EN
+
+#define CFG_SPI_FREQ 180000000 
+
+#define MAX_RCV_SZ   0x1000
+#define DMA_RD_BAUD  0x10
+#define DMA_WR_BAUD  0x10
+#define IO_RD_BAUD   0x10
+#define IO_WR_BAUD   0x10
+
+#ifdef CONFIG_SPI_DMA_EN
+#define RD_BAUD DMA_RD_BAUD
+#define WR_BAUD DMA_WR_BAUD
+#else
+#define RD_BAUD IO_RD_BAUD
+#define WR_BAUD IO_WR_BAUD
+#endif
+
+
+unsigned char alen = 3;
+
+static void inline spin_wheel (void)
+{
+	static int p = 0;
+	static char w[] = "\\/-";
+
+	printf ("\010%c", w[p]);
+	(++p == 3) ? (p = 0) : 0;
+}
+
+void spi__init(void)
+{
+	unsigned int ctrl0 = 0;
+
+    /* enable spi pinmux */
+	spi_write(SPI_PINMUX, 0x1);
+
+	/* Disable the ssi by write 0 to SSIEN,tx and rx buffer was cleared */
+	spi_write(rSSIENR, 0x0);
+
+	/* Config the CTRLR0 register */
+    ctrl0 = 0x0 << 12  | /* CFS (Control Frame Size). 4bit length */
+        0x0 << 11  |     /* SRL 0:nomormod;1:test mode            */
+        0x0 << 10  |     /* SLV_OE                                */
+        0x0 << 8   |     /* TMOD master  TODO 0                   */
+        0x1 << 7   |     /* SCPOL clock inactive state            */
+        0x1 << 6   |     /* SCPH                                  */
+        0x0 << 4   |     /* frame format select  SPI              */
+        0x7 << 0;        /* DFS data frame size                   */
+
+	/*  rCTRLR0=0x2B00; receive and transmit enable */
+
+	spi_write(rCTRLR0, ctrl0);
+
+	/* ctrl1 */
+	spi_write(rCTRLR1, (MAX_RCV_SZ-1));
+
+	/* SSI_CLK baud out */
+	spi_write(rBAUDR, IO_WR_BAUD);
+
+	/* rSER, select the device */
+	spi_write(rSER, 0x1);
+
+	/* rSSIENR, enable the ssi bus */
+	spi_write(rSSIENR, 0x1);
+
+/*    alen = spi_read(BOOTCFG)>>5 & 0x3;*/
+}
+
+#if 0
+void spi_baud(unsigned short baud)
+{
+	spi_write(rSSIENR, 0x0);
+	spi_write(rBAUDR, baud);
+	spi_write(rSSIENR, 0x1);
+}
+
+static void master_set_mode(TMOD_E tmod, TIMING_E tm)
+{
+	unsigned short ctrl0 = spi_read(rCTRLR0);
+
+	ctrl0 &= ~(0xf<<6);
+	ctrl0 |= (tmod<<8 | tm<<6);
+
+	spi_write(rSSIENR, 0x0);
+	spi_write(rCTRLR0, ctrl0);
+	spi_write(rSSIENR, 0x1);
+}
+static unsigned char master_check_mode(TMOD_E tmod, TIMING_E tm)
+{
+	unsigned short ctrl0 = spi_read(rCTRLR0);
+
+	if (ctrl0 & (tmod<<8 | tm<<6))
+		return 1;
+
+	return 0;
+}
+
+/*===================================================================
+ * 	flash oepration
+ */
+static inline void read_out_data(volatile unsigned char *buf, int size)
+{
+	int i = 0, j = 0;
+
+	while (i < size) {
+		while (!(j = spi_read(rRXFLR)));
+		while (j > 0) {
+			if (buf) buf[i] = spi_read(rDR);
+			else     spi_read(rDR);
+
+			i++; j--;
+		}
+	}
+}
+
+static inline unsigned char flash_status(void)
+{
+	unsigned char buf[2];
+
+	/* If check fail, return 0xff, also satisfy while's condition */
+	if (! master_check_mode(TMOD_TXRX, TIMING3))
+		return -1;
+
+	spi_write(rDR, CMD_RDSR); spi_write(rDR, 0x0);
+	read_out_data(buf, 2);
+/*    printf("status: %x\n", buf[1]);*/
+	return buf[1];
+}
+
+static void wait_for_finish(void)
+{
+	int tmp = 0;
+
+	while (flash_status() & 1) {
+		udelay(1000);
+		if (!(tmp % 100))
+			spin_wheel();
+		tmp++;
+	}
+}
+
+/* Only Used For Erase Read Write */
+static void flash_send_cmd(unsigned char cmd, unsigned int caddr)
+{
+	int i;
+	unsigned char *byte_addr = (unsigned char *) &caddr;
+
+	if (/*CMD_PP == cmd || */ CMD_SE == cmd ||
+	    CMD_BE == cmd || CMD_CE == cmd) {
+
+		master_set_mode(TMOD_TXRX, TIMING3);
+		if (CMD_CE == cmd) {
+			spi_write(rDR, cmd);
+			read_out_data(NULL, 1);
+		} else {
+			spi_write(rDR, cmd);
+			for (i = alen - 1; i >= 0; i--)
+				spi_write(rDR, byte_addr[i]);
+
+			/*if (CMD_PP != cmd)*/
+				read_out_data(NULL, alen+1);
+		}
+
+	} else if (CMD_WREN == cmd) {
+
+/*                master_set_mode(TMOD_TXRX, TIMING3);*/
+		master_set_mode(TMOD_TXRX, TIMING0);
+		spi_write(rDR, cmd);
+		read_out_data(NULL, 1);
+
+	} else if (CMD_PP == cmd) {
+
+		master_set_mode(TMOD_TX, TIMING3);
+		spi_write(rDR, cmd);
+		for (i = alen - 1; i >= 0; i--)
+			spi_write(rDR, byte_addr[i]);
+
+	} else if (CMD_READ == cmd || CMD_RDID == cmd) {
+
+		master_set_mode(TMOD_EE, TIMING3);
+		if (CMD_RDID == cmd) {
+			spi_write(rDR, cmd);
+		} else {
+			spi_write(rDR, cmd);
+			for (i = alen - 1; i >= 0; i--)
+				spi_write(rDR, byte_addr[i]);
+		}
+
+	} else {
+		printf("flash_send_cmd: Not Support this command!\n");
+	}
+
+	return;
+}
+#endif
+
+static inline void wait_for_finish(void)
+{
+	unsigned int status;
+
+	spi_write(rSSIENR,  0x0     );
+	spi_write(rCTRLR0,  0x3c7   );
+	spi_write(rCTRLR1,  0x0     );
+	spi_write(rSSIENR,  0x1     );
+
+	do {
+		spi_write(rDR,  CMD_RDSR);
+		while(spi_read(rRXFLR) != 1);
+		status = spi_read(rDR);
+/*        printf("status : %x\n", status);*/
+		//spin_wheel();
+	} while(status & 0x1);
+}
+
+static int _flash_read(unsigned int caddr, unsigned char *buf, int size)
+{
+	unsigned char *addr = (unsigned char *)&caddr;
+
+	spi_write(rSSIENR, 0x0);
+	spi_write(rCTRLR0, 0x3c7);
+	spi_write(rCTRLR1, (MAX_RCV_SZ-1));
+	spi_write(rBAUDR,  IO_RD_BAUD);
+	spi_write(rSSIENR, 0x1);
+
+	spi_write(rDR, CMD_READ);
+	spi_write(rDR, addr[2]);
+	spi_write(rDR, addr[1]);
+	spi_write(rDR, addr[0]);
+
+	while (size > 0) {
+		if (size >= 16) {
+			while (spi_read(rRXFLR) < 16);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			size -= 16;
+		} else if (size >= 8) {
+			while (spi_read(rRXFLR) < 8);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			size -= 8;
+		} else if (size >= 4) {
+			while (spi_read(rRXFLR) < 4);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			size -= 4;
+		} else if (size >= 2) {
+			while (spi_read(rRXFLR) < 2);
+			*buf++ = spi_read(rDR);
+			*buf++ = spi_read(rDR);
+			size -= 2;
+		} else if (size > 0) {
+			while (spi_read(rRXFLR) == 0);
+			*buf++ = spi_read(rDR);
+			size -= 1;
+		}
+	}
+
+	while ((spi_read(rSR) & 0x5) != 0x4);
+	udelay (100);
+
+#if 0
+	if (spi_read(rSR) & (1<<5))
+		printf("Error   T error! 5 \n");
+
+	if (spi_read(rSR) & (1<<6))
+		printf("Error   T data error! 6 \n");
+#endif
+
+	return 0;
+}
+
+static int _flash_write(unsigned int caddr, volatile unsigned char *buf, int size)
+{
+	unsigned char *addr = (unsigned char *)&caddr;
+
+	/* Unprotect flash */
+	spi_write(rSSIENR, 0x0);
+	spi_write(rCTRLR0, 0x107);
+	spi_write(rSSIENR, 0x1);
+	spi_write(rDR, CMD_WREN);
+	while ((spi_read(rSR) & 0x5) != 0x4);
+
+	spi_write(rSSIENR, 0x0);
+	spi_write(rCTRLR0, 0x1c7);
+	spi_write(rBAUDR,  IO_WR_BAUD);
+	spi_write(rSSIENR, 0x1);
+
+	spi_write(rDR, CMD_PP);
+	spi_write(rDR, addr[2]);
+	spi_write(rDR, addr[1]);
+	spi_write(rDR, addr[0]);
+
+	while (size) {
+		if (size >= 16) {
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			while (spi_read(rTXFLR) > 8);
+			size -= 16;
+		} else if (size >= 8) {
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			while (spi_read(rTXFLR) > 8);
+			size -= 8;
+		} else if (size >= 4) {
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			while (spi_read(rTXFLR) > 8);
+			size -= 4;
+		} else if (size >= 2) {
+			spi_write(rDR, *buf++);
+			spi_write(rDR, *buf++);
+			while (spi_read(rTXFLR) > 8);
+			size -= 2;
+		} else if (size > 0) {
+			spi_write(rDR, *buf++);
+			while (spi_read(rTXFLR) > 8);
+			size -= 1;
+		}
+	}
+
+	while ((spi_read(rSR) & 0x5) != 0x4);
+
+	wait_for_finish();
+
+	return 0;
+}
+
+static int _flash_erase(unsigned int caddr, unsigned short cmd)
+{
+	unsigned char *addr = (unsigned char *)&caddr;
+
+	/* Unprotect flash */
+	spi_write(rSSIENR, 0x0);
+	spi_write(rCTRLR0, 0x107);
+	spi_write(rSSIENR, 0x1);
+	spi_write(rDR, CMD_WREN);
+	while ((spi_read(rSR) & 0x5) != 0x4);
+
+	spi_write(rSSIENR, 0x0);
+	spi_write(rBAUDR, IO_WR_BAUD);
+	spi_write(rCTRLR0, 0x1c7);
+	spi_write(rSSIENR, 0x1);
+
+	spi_write(rDR, cmd);
+	spi_write(rDR, addr[2]);
+	spi_write(rDR, addr[1]);
+	spi_write(rDR, addr[0]);
+	while ((spi_read(rSR) & 0x5) != 0x4);
+
+	wait_for_finish();
+
+	return 0;
+}
+
+
+#define  WriteReg(a, v) 		(*(volatile unsigned int *)(a) = (v))
+#define  WriteReg8(a, v) 		(*(volatile unsigned char *)(a) = (v))
+#define  WriteReg32(a, v) 		(*(volatile unsigned int *)(a) = (v))
+#define  WriteReg16(a, v) 		(*(volatile unsigned short *)(a) = (v))
+
+#define  ReadReg(a) 			(*(volatile unsigned int *)(a))
+#define  ReadReg8(a) 			(*(volatile unsigned char *)(a))
+#define  ReadReg16(a) 			(*(volatile unsigned short *)(a))
+#define  ReadReg32(a) 			(*(volatile unsigned int *)(a))
+
+enum {
+    SPI_CTRLR0      = 0x80150000,
+    SPI_CTRLR1      = 0x80150004,
+    SPI_SSIENR      = 0x80150008,
+    SPI_SER         = 0x80150010,
+    SPI_BAUDR       = 0x80150014,
+    SPI_TXFLR       = 0x80150020,
+    SPI_RXFLR       = 0x80150024,
+    SPI_SR          = 0x80150028,
+    SPI_IMR         = 0x8015002c,
+    SPI_DMACR       = 0x8015004c,
+    SPI_DMATDLR     = 0x80150050,
+    SPI_DMARDLR     = 0x80150054,
+    SPI_DR          = 0x80150060,
+
+    PINMUX_SPI      = 0xB211000c,
+
+    SAR0            = 0x80154000,
+    DAR0            = 0x80154008,
+    LLP0            = 0x80154010,
+    CTL0            = 0x80154018,
+    SSTAT0          = 0x80154020,
+    DSTAT0          = 0x80154028,
+    SSTATAR0        = 0x80154030,
+    DSTATAR0        = 0x80154038,
+    CFG0            = 0x80154040,
+    SGR0            = 0x80154048,
+    DSR0            = 0x80154050,
+
+	RawTfr			= 0x801542c0,
+	RawBlock		= 0x801542c8,
+	RawDstTran		= 0x801542d0,
+	RawSrcTran		= 0x801542d8,
+	RawErr			= 0x801542e0,
+
+	StatusTfr		= 0x801542e8,
+	StatusBlock		= 0x801542f0,
+	StatusSrcTran	= 0x801540f8,
+	StatusDstTran	= 0x80154300,
+	StatusErr		= 0x80154308,
+
+	StatusInt		= 0x80154360,
+
+    MASK_TFR        = 0x80154310,
+    CLEAR_TFR       = 0x80154338,
+    CHEN            = 0x801543a0,
+    DMACFG          = 0x80154398,
+    MaskTfr         = 0x80154310,
+    ClearTfr        = 0x80154338
+};
+
+#if defined(CONFIG_SPI_DMA_EN)
+
+static inline void SetupDMA_LLP_SG_RX(const u32 caddr, u32 maddr, u32 size)
+{
+    unsigned int llp = CONFIG_SPI_DMA_BUF_BASE;
+    unsigned int ctl_lo =  0   /* CTL[31:0]                    */
+              | ( 0x1  << 28)  /* LLP_SRC_EN                   */
+              | ( 0x1  << 27)  /* LLP_DST_EN                   */
+              | ( 0x0  << 25)  /* SRC Master                   */
+              | ( 0x1  << 23)  /* DST Master                   */
+              | ( 0x2  << 20)  /* P -> M, M as flow controller */
+              | ( 0x0  << 18)  /* DSCATTER_EN                  */
+              | ( 0x0  << 17)  /* SGATHER_EN                   */
+              | ( 0x1  << 14)  /* SMSIZE:  4 * 1B              */
+              | ( 0x3  << 11)  /* DMSIZE: 16 * 4B              */
+              | ( 0x2  <<  9)  /* SINC: no change              */
+              | ( 0x0  <<  7)  /* DINC: increment              */
+              | ( 0x0  <<  4)  /* SRC_TR_WIDTH:  8b            */
+              | ( 0x2  <<  1)  /* DST_TR_WIDTH: 32b            */
+              | ( 0x0  <<  0); /* INT_EN                       */
+
+
+    /* 4B align */
+    if (size & 0x3) {
+        printf("%s: size not 4B align!\n", __func__);
+        return;
+    }
+
+    /* Controller init */
+    WriteReg16(SPI_SSIENR , 0x0              );
+    WriteReg16(SPI_CTRLR0 , 0x3c7            );
+    WriteReg16(SPI_CTRLR1 , (size-1)         );
+    WriteReg16(SPI_BAUDR  , DMA_RD_BAUD          );
+    WriteReg16(SPI_DMARDLR, 3                ); /* When 4bytes got, send to DMA controller immediately */
+    WriteReg16(SPI_DMACR  , 0x1              ); /* Receive FIFO DMA request enabled */
+    WriteReg16(SPI_SSIENR , 0x1              );
+
+    /* DMA enable */
+    WriteReg(DMACFG,    0x1                  ); /* Gloabl Enable */
+
+    WriteReg(llp +  0, SPI_DR                ); /* SAR           */
+    WriteReg(llp +  4, maddr                 ); /* DAR           */
+    WriteReg(llp +  8, (llp + 32) | 0x1      ); /* Next LLP from previous llp */
+    WriteReg(llp + 12, ctl_lo                );
+    WriteReg(llp + 16, (size>2048)?2048:size );
+
+    if (size > 2048) {
+    WriteReg(llp + 32, SPI_DR                ); /* SAR      */
+    WriteReg(llp + 36, maddr+2048            ); /* DAR      */
+    WriteReg(llp + 40, 0                     ); /* Next LLP */
+    WriteReg(llp + 44, ctl_lo                );
+    WriteReg(llp + 48, size-2048             );
+    } else
+    WriteReg(llp + 8, 0                      );
+
+#if 0
+	{
+		int i;
+		for (i = 0; i <= 48; i+=4) {
+			printf("%d: -------------- 0x%x\n",i, ReadReg(llp+i));
+		}
+		printf("\n");
+		printf("\n");
+	}
+#endif
+
+    WriteReg(CTL0,      0x3 << 27            ); /* LLP_SRC_EN/LLP_DST_EN                           */
+    WriteReg(CFG0 + 4,  0x1 <<  7            ); /* use RX handshaking signals for source periphral */
+    WriteReg(CFG0,      0x1 << 10            ); /* HS_SEL_DST = 0 (HW), HS_SEL_DST = 1 (SW)        */
+    WriteReg(LLP0,      llp | 0x1            ); /* LMS = 1, external DRAM                          */
+    WriteReg(CHEN,      (0x1 << 8) | 0x1     ); /* Enable the only channel                         */
+
+    WriteReg(ClearTfr,  0x1                  );
+    WriteReg(MaskTfr,   (0x1 << 8) | 0x1     );
+
+    /* Send Read command */
+    WriteReg16(SPI_SSIENR , 0x3              );
+    WriteReg16(SPI_DR, CMD_READ           );
+    WriteReg16(SPI_DR, (caddr>>16) & 0xff );
+    WriteReg16(SPI_DR, (caddr>>8)  & 0xff );
+    WriteReg16(SPI_DR, (caddr)     & 0xff );
+    WriteReg16(SPI_SSIENR , 0x1              );
+
+    /* Wait dma finished  */
+    while (ReadReg(CHEN));
+}
+
+static inline void SetupDMA_LLP_SG_TX(u32 caddr, const u32 maddr, u32 size)
+{
+    unsigned int llp = CONFIG_SPI_DMA_BUF_BASE;
+    unsigned int ctl_lo =  0     /* CTL[31:0]                    */
+                | ( 0x1  << 28)  /* LLP_SRC_EN                   */
+                | ( 0x1  << 27)  /* LLP_DST_EN                   */
+                | ( 0x1  << 25)  /* SRC Master                   */
+                | ( 0x0  << 23)  /* DST Master                   */
+                | ( 0x1  << 20)  /* M -> P, M as flow controller */
+                | ( 0x0  << 18)  /* DSCATTER_EN                  */
+                | ( 0x0  << 17)  /* SGATHER_EN                   */
+                | ( 0x3  << 14)  /* SMSIZE: 16 * 4B              */
+                | ( 0x1  << 11)  /* DMSIZE:  4 * 1B              */
+                | ( 0x0  <<  9)  /* SINC: increment              */
+                | ( 0x2  <<  7)  /* DINC: no charge              */
+                | ( 0x2  <<  4)  /* SRC_TR_WIDTH: 32b            */
+                | ( 0x0  <<  1)  /* DST_TR_WIDTH:  8b            */
+                | ( 0x1  <<  0); /* INT_EN                       */
+
+    /* 4 Byte align */
+    if (size & 0x3) {
+        printf("%s: size not 4B align!\n", __func__);
+        return;
+    }
+
+    /* Unprotect flash */
+    spi_write(rSSIENR, 0x0               );
+    spi_write(rCTRLR0, 0x107             );
+    spi_write(rSSIENR, 0x1               );
+    spi_write(rDR    , CMD_WREN          );
+    while ((spi_read(rSR) & 0x5) != 0x4  );
+
+    /* Init Controller */
+    WriteReg16(SPI_SSIENR , 0x0          );
+    WriteReg16(SPI_BAUDR  , DMA_WR_BAUD      );
+    WriteReg16(SPI_CTRLR0 , 0x1c7        ); /* Transmit Only                                                */
+    WriteReg16(SPI_DMATDLR, 16           ); /* When FIFO half full, receive from DMA controller immediately */
+    WriteReg16(SPI_DMACR  , 0x2          ); /* Transmit FIFO DMA request enabled                            */
+    WriteReg16(SPI_SSIENR , 0x1          );
+
+    /* Enable DMA */
+    WriteReg(DMACFG,    0x1              ); /* Gloabl Enable                                   */
+
+    WriteReg(llp +  0, maddr             ); /* SAR                                             */
+    WriteReg(llp +  4, SPI_DR            ); /* DAR                                             */
+    WriteReg(llp +  8, 0                 ); /* Next LLP                                        */
+    WriteReg(llp + 12, ctl_lo            );
+    WriteReg(llp + 16, (size + 4) / 4    ); /* 256B data + 4B command                          */
+
+    WriteReg(CTL0,      0x3 << 27        ); /* LLP_SRC_EN/LLP_DST_EN                           */
+    WriteReg(CFG0 + 4,  0x0 <<  7        ); /* use TX handshaking signals for source periphral */
+    WriteReg(CFG0,      0x2 << 10        ); /* HS_SEL_DST = 0 (HW), HS_SEL_DST = 1 (SW)        */
+    WriteReg(LLP0,      llp | 0x1        ); /* LMS = 1, external DRAM                          */
+    WriteReg(CHEN,      (0x1 << 8) | 0x1 ); /* Enable the only channel                         */
+
+    WriteReg(ClearTfr,  0x1              );
+    WriteReg(MaskTfr,   (0x1 << 8) | 0x1 );
+
+    /* Wait dma finish  */
+    while (ReadReg(CHEN));
+    /* Wait spi transfer finish  */
+    while((ReadReg16(SPI_SR) & 0x5) != 0x4);
+    /* Wait flash program finish */
+    wait_for_finish();
+}
+
+
+#if 0
+int do_sflashre_dma(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	unsigned char *maddr;
+	unsigned int caddr;
+	unsigned int size;
+
+	if (argc != 4) {
+		printf("Usage: %s\n", cmdtp->help);
+		return -1;
+	}
+
+	maddr = (unsigned char *)simple_strtoul(argv[1], NULL, 16);
+	caddr = simple_strtoul(argv[2], NULL, 16);
+	size = simple_strtoul(argv[3], NULL, 16);
+
+	printf("caddr: 0x%x, maddr: 0x%x, size: 0x%x\n",
+	      caddr, maddr, size);
+
+	seeprom_read(caddr, maddr, size);
+
+	return 0;
+}
+
+U_BOOT_CMD(
+	sfdre,	CFG_MAXARGS/*5*/,	0,	do_sflashre_dma,
+	"sfre    - spi flash read byte.\n",
+	"\nsfre <maddr> <offset> <len>\n"
+	);
+#endif
+
+#endif /* CONFIG_SPI_DMA */
+
+/*--------------------------------------------------------------------------------*/
+
+int seeprom_read(unsigned caddr, uchar *maddr, unsigned size)
+{
+	unsigned cnt;
+
+    /* Make sure 4B align */
+    if (size & 0x3)
+        size = ((size + 4) >> 2) << 2;
+
+	while (size > 0) {
+		cnt = (size >= MAX_RCV_SZ) ? MAX_RCV_SZ : size;
+
+#if defined(CONFIG_SPI_DMA_EN)
+		/* DMA controller */
+		SetupDMA_LLP_SG_RX((u32)caddr, (u32)maddr, cnt );
+#else
+		_flash_read(caddr, maddr, cnt);
+#endif
+
+		caddr += cnt;
+		maddr += cnt;
+		size  -= cnt;
+	}
+
+    /* fix dma bug, reload with 4byte offset */
+    WriteReg16(SPI_SSIENR , 0x0 );
+    WriteReg16(SPI_DMARDLR, 0x0 );
+    WriteReg16(SPI_DMACR  , 0x0 );
+    WriteReg16(SPI_SSIENR , 0x1 );
+
+	return 0;
+}
+
+int seeprom_write(unsigned caddr, uchar *maddr, unsigned size)
+{
+	unsigned cnt;
+#if defined(CONFIG_SPI_DMA_EN)
+	unsigned int v_bak;
+#endif
+
+	printf("Page Write from 0x%x to 0x%x ...  ", (unsigned int)maddr, caddr);
+
+	while (size > 0) {
+		cnt = (size >= PP_SZ) ? PP_SZ : size;
+
+#if defined(CONFIG_SPI_DMA_EN)
+        /* Backup Address */
+		v_bak = *(unsigned int *)(maddr - 4);
+
+        /* Initialize Write Command */
+        WriteReg8((maddr-4),  CMD_PP           );
+        WriteReg8((maddr-3),  (caddr>>16)&0xff );
+        WriteReg8((maddr-2),  (caddr>>8)&0xff  );
+        WriteReg8((maddr-1),  (caddr)&0xff     );
+
+        if (cnt % 0x3)
+            _flash_write(caddr, maddr, cnt);
+        else
+            SetupDMA_LLP_SG_TX((u32)caddr, (u32)(maddr-4), cnt);
+
+        /* Restore Address */
+		*(unsigned int *)(maddr - 4) = v_bak;
+#else
+		_flash_write(caddr, maddr, cnt);
+#endif
+
+		caddr += cnt;
+		maddr += cnt;
+		size  -= cnt;
+	}
+	printf(" ok!\n");
+
+	return 0;
+}
+
+int seeprom_erase(unsigned cmd, unsigned saddr, unsigned size)
+{
+	unsigned eaddr;
+	unsigned sector_size = gd->sf_inf->sector_size;
+
+	eaddr = saddr + size;
+	if (eaddr > gd->sf_size)
+		eaddr = gd->sf_size;
+
+	switch (cmd) {
+		case CMD_CE: /* chip */
+			printf("Chip Erase ...  ");
+			_flash_erase(saddr, cmd);
+			break;
+
+		case CMD_BE: /* block */
+			printf("Block Erase from 0x%x to 0x%x ...  ", saddr, eaddr);
+			if (gd->sf_inf->jedec_id == 0x1c2017)
+				if (saddr < 0x10000) {
+					_flash_erase(0x0000, cmd);
+					_flash_erase(0x1000, cmd);
+					_flash_erase(0x2000, cmd);
+					_flash_erase(0x4000, cmd);
+					_flash_erase(0x8000, cmd);
+
+					if (eaddr >= 0x10000)
+						saddr = 0x10000;
+				}
+
+			while (saddr < eaddr) {
+				_flash_erase(saddr, cmd);
+				saddr+=sector_size;
+			}
+			break;
+
+		case CMD_SE:	/* sector */
+			printf("Sector Erase from 0x%x to 0x%x ...  ", saddr, eaddr);
+			while (saddr < eaddr) {
+				_flash_erase(saddr, cmd);
+				saddr+=0x1000;
+			}
+			break;
+
+		default:
+			printf("Error! No such chioce.\n");
+			return -1;
+	}
+	printf(" ok!\n");
+
+	return 0;
+}
+
+static sfinf_t sflash_data [] = {
+	/* Winbond */
+	{ "W25D80", 0xef3014, 0, 4 * 1024, 256},
+	{ "W25D16", 0xef3015, 0, 4 * 1024, 512},
+	{ "W25D32", 0xef3016, 0, 4 * 1024, 1024},
+	{ "W25D64", 0xef3017, 0, 4 * 1024, 2048},
+	{ "W25Q80", 0xef4014, 0, 4 * 1024, 256},
+	{ "W25Q16", 0xef4015, 0, 4 * 1024, 512},
+	{ "W25Q32", 0xef4016, 0, 4 * 1024, 1024},
+	{ "W25Q64", 0xef4017, 0, 4 * 1024, 2048},
+	{ "W25Q128", 0xef4018, 0, 4 * 1024, 4096},
+	{ "W25Q64DW", 0xef6017, 0, 4 * 1024, 2048},
+	/* Macronix */
+	{ "MX25L4006E", 0xc22013, 0, 4 * 1024, 128},
+	{ "MX25L8006E", 0xc22014, 0, 4 * 1024, 256},
+	{ "MX25L1605D", 0xc22015, 0, 4 * 1024, 512},
+	{ "MX25L3205D", 0xc22016, 0, 4 * 1024, 1024},
+	{ "MX25L6405D/6406E", 0xc22017, 0, 4 * 1024, 2048},
+	{ "MX25L12805D", 0xc22018, 0, 4 * 1024, 4096},
+	{ "MX25L12855E", 0xc22618, 0, 4 * 1024, 4095},
+	{ "MX25L512E", 0xc22010, 0, 4 * 1024, 16},
+	/* Giga Devices */
+	{ "GD25Q512", 0xc84010, 0, 4 * 1024, 16,},
+	{ "GD25Q80",  0xc84014, 0, 4 * 1024, 256,},
+	{ "GD25Q64",  0xc84017, 0, 4 * 1024, 2048,},
+};
+
+static void get_manufacture_id(unsigned char *buf, int size)
+{
+	spi_write(rSSIENR, 0x0);
+	spi_write(rCTRLR0, 0x3c7);
+	spi_write(rCTRLR1, 0x4);
+	spi_write(rSSIENR, 0x1);
+
+	spi_write(rDR, CMD_RDID);
+	while (spi_read(rRXFLR) < 5);
+
+	*buf++ = spi_read(rDR);
+	*buf++ = spi_read(rDR);
+	*buf++ = spi_read(rDR);
+	*buf++ = spi_read(rDR);
+	*buf++ = spi_read(rDR);
+}
+
+int seeprom_probe(void)
+{
+	int			tmp;
+	u8			id[5];
+	u32			jedec;
+	u16                     ext_jedec;
+	struct sflash_info	*info;
+
+	get_manufacture_id(id, 5);
+	jedec = id[0];
+	jedec = jedec << 8;
+	jedec |= id[1];
+	jedec = jedec << 8;
+	jedec |= id[2];
+
+	ext_jedec = id[3] << 8 | id[4];
+
+	for (tmp = 0, info = sflash_data;
+			tmp < ARRAY_SIZE(sflash_data);
+			tmp++, info++) {
+		if (info->jedec_id == jedec) {
+			if (info->ext_id != 0 && info->ext_id != ext_jedec)
+				continue;
+			goto found;
+		}
+	}
+
+	printf("SPI Probe Fail! No Such Devices! --- jedec id: 0x%08x\n", jedec);
+
+	return 0;
+
+found:
+	gd->sf_inf = info;
+	gd->sf_alen = alen;
+	if ((spi_read(BOOTCFG) & 0x1) &&
+	    (spi_read(BOOTCFG) & 0x10))
+		gd->sf_boot = 1;
+	else 	gd->sf_boot = 0;
+
+	gd->sf_rspd = CFG_SPI_FREQ/1000000/RD_BAUD;
+	gd->sf_wspd = CFG_SPI_FREQ/1000000/WR_BAUD;
+    //printf("RD_BAUD=%d, WR_BAUD=%d, gd-sf_rspd=%d", RD_BAUD, WR_BAUD,gd->sf_rspd);
+	gd->sf_size  = info->sector_size * info->n_sectors;
+
+	return 1;
+}
+
+#endif //(CONFIG_COMMANDS & CFG_CMD_SPI)
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/spi/gigadevice.c u-boot-2011.06/drivers/mtd/spi/gigadevice.c
--- u-boot-2011.06_original/drivers/mtd/spi/gigadevice.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/gigadevice.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,204 @@
+/*
+ * Copyright 2008, Network Appliance Inc.
+ * Author: Jason McMullan <mcmullan <at> netapp.com>
+ * Licensed under the GPL-2 or later.
+ */
+
+#include <common.h>
+#include <malloc.h>
+#include <spi_flash.h>
+
+#include "spi_flash_internal.h"
+
+/* M25Pxx-specific commands */
+#define CMD_W25_WREN		0x06	/* Write Enable */
+#define CMD_W25_WRDI		0x04	/* Write Disable */
+#define CMD_W25_RDSR		0x05	/* Read Status Register */
+#define CMD_W25_WRSR		0x01	/* Write Status Register */
+#define CMD_W25_READ		0x03	/* Read Data Bytes */
+#define CMD_W25_FAST_READ	0x0b	/* Read Data Bytes at Higher Speed */
+#define CMD_W25_PP		0x02	/* Page Program */
+#define CMD_W25_SE		0x20	/* Sector (4K) Erase */
+#define CMD_W25_BE		0xd8	/* Block (64K) Erase */
+#define CMD_W25_CE		0xc7	/* Chip Erase */
+#define CMD_W25_DP		0xb9	/* Deep Power-down */
+#define CMD_W25_RES		0xab	/* Release from DP, and Read Signature */
+
+struct gigadevice_spi_flash_params {
+	uint16_t	id;
+	/* Log2 of page size in power-of-two mode */
+	uint8_t		l2_page_size;
+	uint16_t	pages_per_sector;
+	uint16_t	sectors_per_block;
+	uint16_t	nr_blocks;
+	const char	*name;
+};
+
+/* spi_flash needs to be first so upper layers can free() it */
+struct gigadevice_spi_flash {
+	struct spi_flash flash;
+	const struct gigadevice_spi_flash_params *params;
+};
+
+static inline struct gigadevice_spi_flash *
+to_gigadevice_spi_flash(struct spi_flash *flash)
+{
+	return container_of(flash, struct gigadevice_spi_flash, flash);
+}
+
+static const struct gigadevice_spi_flash_params gigadevice_spi_flash_table[] = {
+	{
+		.id			= 0x4014,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 16,
+		.name			= "GD25Q80",
+	},
+	{
+		.id			= 0x4015,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 32,
+		.name			= "GD25Q16",
+	},
+	{
+		.id			= 0x4016,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 64,
+		.name			= "GD25Q32",
+	},
+	{
+		.id			= 0x4017,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 128,
+		.name			= "GD25Q64",
+	},
+	{
+		.id			= 0x4018,
+		.l2_page_size		= 8,
+		.pages_per_sector	= 16,
+		.sectors_per_block	= 16,
+		.nr_blocks		= 256,
+		.name			= "GD25Q128",
+	},
+};
+
+static int gigadevice_write(struct spi_flash *flash,
+		u32 offset, size_t len, const void *buf)
+{
+	struct gigadevice_spi_flash *stm = to_gigadevice_spi_flash(flash);
+	unsigned long page_addr;
+	unsigned long byte_addr;
+	unsigned long page_size;
+	unsigned int page_shift;
+	size_t chunk_len;
+	size_t actual;
+	int ret;
+	u8 cmd[4];
+
+	page_shift = stm->params->l2_page_size;
+	page_size = (1 << page_shift);
+	page_addr = offset / page_size;
+	byte_addr = offset % page_size;
+
+	ret = spi_claim_bus(flash->spi);
+	if (ret) {
+		debug("SF: Unable to claim SPI bus\n");
+		return ret;
+	}
+
+	for (actual = 0; actual < len; actual += chunk_len) {
+		chunk_len = min(len - actual, page_size - byte_addr);
+
+		cmd[0] = CMD_W25_PP;
+		cmd[1] = page_addr >> (16 - page_shift);
+		cmd[2] = page_addr << (page_shift - 8) | (byte_addr >> 8);
+		cmd[3] = byte_addr;
+		debug("PP: 0x%p => cmd = { 0x%02x 0x%02x%02x%02x } chunk_len = %d\n",
+			buf + actual,
+			cmd[0], cmd[1], cmd[2], cmd[3], chunk_len);
+
+		ret = spi_flash_cmd(flash->spi, CMD_W25_WREN, NULL, 0);
+		if (ret < 0) {
+			debug("SF: Enabling Write failed\n");
+			goto out;
+		}
+
+		ret = spi_flash_cmd_write(flash->spi, cmd, 4,
+				buf + actual, chunk_len);
+		if (ret < 0) {
+			debug("SF: GD Page Program failed\n");
+			goto out;
+		}
+
+		ret = spi_flash_cmd_wait_ready(flash, SPI_FLASH_PROG_TIMEOUT);
+		if (ret)
+			goto out;
+
+		page_addr++;
+		byte_addr = 0;
+	}
+
+	debug("SF: GD: Successfully programmed %u bytes @ 0x%x\n",
+			len, offset);
+	ret = 0;
+
+out:
+	spi_release_bus(flash->spi);
+	return ret;
+}
+
+static int gigadevice_erase(struct spi_flash *flash, u32 offset, size_t len)
+{
+	return spi_flash_cmd_erase(flash, CMD_W25_SE, offset, len);
+}
+
+struct spi_flash *spi_flash_probe_gigadevice(struct spi_slave *spi, u8 *idcode)
+{
+	const struct gigadevice_spi_flash_params *params;
+	unsigned page_size;
+	struct gigadevice_spi_flash *stm;
+	unsigned int i;
+
+	for (i = 0; i < ARRAY_SIZE(gigadevice_spi_flash_table); i++) {
+		params = &gigadevice_spi_flash_table[i];
+		if (params->id == ((idcode[1] << 8) | idcode[2]))
+			break;
+	}
+
+	if (i == ARRAY_SIZE(gigadevice_spi_flash_table)) {
+		debug("SF: Unsupported GigaDevice ID %02x%02x\n",
+				idcode[1], idcode[2]);
+		return NULL;
+	}
+
+	stm = malloc(sizeof(struct gigadevice_spi_flash));
+	if (!stm) {
+		debug("SF: Failed to allocate memory\n");
+		return NULL;
+	}
+
+	stm->params = params;
+	stm->flash.spi = spi;
+	stm->flash.name = params->name;
+
+	/* Assuming power-of-two page size initially. */
+	page_size = 1 << params->l2_page_size;
+
+	stm->flash.write = gigadevice_write;
+	stm->flash.erase = gigadevice_erase;
+	stm->flash.read = spi_flash_cmd_read_fast;
+	stm->flash.sector_size = (1 << stm->params->l2_page_size) *
+		stm->params->pages_per_sector;
+	stm->flash.size = page_size * params->pages_per_sector
+				* params->sectors_per_block
+				* params->nr_blocks;
+
+	return &stm->flash;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/spi/macronix.c u-boot-2011.06/drivers/mtd/spi/macronix.c
--- u-boot-2011.06_original/drivers/mtd/spi/macronix.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/drivers/mtd/spi/macronix.c	2015-09-18 12:03:14.952265000 +0800
@@ -71,6 +71,30 @@
 
 static const struct macronix_spi_flash_params macronix_spi_flash_table[] = {
 	{
+		.idcode = 0x2012,
+		.page_size = 256,
+		.pages_per_sector = 16,
+		.sectors_per_block = 16,
+		.nr_blocks = 4, 
+		.name = "MX25L2006E",
+	},
+	{
+		.idcode = 0x2013,
+		.page_size = 256,
+		.pages_per_sector = 16,
+		.sectors_per_block = 16,
+		.nr_blocks = 8,
+		.name = "MX25L4006E",
+	},
+	{
+		.idcode = 0x2014,
+		.page_size = 256,
+		.pages_per_sector = 16,
+		.sectors_per_block = 16,
+		.nr_blocks = 16,
+		.name = "MX25L8006E",
+	},
+	{
 		.idcode = 0x2015,
 		.page_size = 256,
 		.pages_per_sector = 16,
@@ -87,6 +111,14 @@
 		.name = "MX25L3205D",
 	},
 	{
+		.idcode = 0x9e16,
+		.page_size = 256,
+		.pages_per_sector = 16,
+		.sectors_per_block = 16,
+		.nr_blocks = 64,
+		.name = "MX25L3255E",
+	},
+{
 		.idcode = 0x2017,
 		.page_size = 256,
 		.pages_per_sector = 16,
diff '--exclude=.svn' -Naur u-boot-2011.06_original/drivers/mtd/spi/Makefile u-boot-2011.06/drivers/mtd/spi/Makefile
